import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Chaos here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Chaos extends World
{
    World toWorld = null;
    int x1, x2, y1, y2, z = 0, p1Leben, p2Leben, originP1L, originP2L, counter1 = 0, counter2 = 0,Verletzung1 = 0, Verletzung2 = 0;
    private Player1 thePlayer1;
    private Player2 thePlayer2;
    private Leben theAnzeige1;
    private Leben theAnzeige2;
    private SpeedShow theSpeed1;
    private SpeedShow theSpeed2;
    private BombsShow theBombs1;
    private BombsShow theBombs2;
    private RadiusShow theRadius1;
    private RadiusShow theRadius2;
    int bombs1, bombs2, radius1, radius2, speed1, speed2;
    int[][] Objekte = new int[15][15];
    /**
     * Constructor for objects of class Chaos.
     * 
     */
    public Chaos(World inWorld, int x1z, int x2z, int y1z, int y2z, int p1l, int p2l, int[][] o, int b1, int b2, int r1, int r2, int s1, int s2)
    {    
        super(1050, 900, 1); 
        toWorld = inWorld; // Speichert die vorherige Welt ab, um später zurückzukehren. Lenni & Flo
        
        // Informationen der Spieler werden gespeichert. Lenni & Flo
        x1 = x1z;
        x2 = x2z;
        y1 = y1z;
        y2 = y2z;
        p1Leben = p1l;
        p2Leben = p2l;
        originP1L = p1l;
        originP2L = p2l;
        Objekte = o;
        bombs1 = b1;
        bombs2 = b2;
        radius1 = r1;
        radius2 = r2;
        speed1 = s1;
        speed2 = s2;
        
        wall();
        prepare();
    }

    public void act()
    {
        z++;
        counter1 = theAnzeige1.getCounter();//die Weitergabe des aktuellen Counterstandes von der Lebensanzeige ermöglicht eine flüssige Blinkanimation. Lenni
        counter2 = theAnzeige2.getCounter();
        if (z==300) 
        {
            if(counter1 == 0) counter1 = 100;//falls der Counter zuende gelaufen ist, soll die Lebensanzeige in Game nicht blinken. Lenni
            if(counter2 == 0) counter2 = 100;
            
            //nach einer gewissen Zeit erstellt Chaos eine Game-Welt, die durch die Informationsweitergabe weitestgehend gleich mit der vorherigen Game-Welt ist. Lenni
            Greenfoot.setWorld(new Game(1, Objekte, Verletzung1, Verletzung2, counter1, counter2, originP1L, originP2L, bombs1, bombs2, radius1, radius2, speed1, speed2, x1, y1, x2, y2));
        }
    }
    
    public void prepare()
    {
        // Spieler werden an vorherigen Positionen erzeugt. Lenni & Flo
        thePlayer1 = new Player1(1,0,1,1,1);//einen bestimmten Player1 erstellen. Lenni
        addObject(thePlayer1, x1, y1);
        thePlayer2 = new Player2(1,0,1,1,1);//einen bestimmten Player2 erstellen. Lenni
        addObject(thePlayer2, x2, y2);
        
        // eine bestimmte Lebensanzeige hinzufügen. Flo
        theAnzeige1 = new Leben (p1Leben, 1, 1, 0, 0);
        addObject(theAnzeige1, 858, 30);
        theAnzeige2 = new Leben (p2Leben, 2, 1, 0, 0);
        addObject(theAnzeige2, 194, 30);
        
         // eine bestimmte Speedanzeige hinzufügen. Flo
        theSpeed1 = new SpeedShow (speed1, 1);
        addObject(theSpeed1, 990, 120);
        theSpeed2 = new SpeedShow (speed2, 2);
        addObject(theSpeed2, 50, 120);
        // eine bestimmte Radiusanzeige hinzufügen. Flo
        theRadius1 = new RadiusShow (radius1, 1);
        addObject(theRadius1, 990, 160);
        theRadius2 = new RadiusShow (radius2, 2);
        addObject(theRadius2, 50, 160);
        // eine bestimmte Bombsanzeige hinzufügen. Flo
        theBombs1 = new BombsShow (bombs1, 1);
        addObject(theBombs1, 990, 200);
        theBombs2 = new BombsShow (bombs2, 2);
        addObject(theBombs2, 50, 200);
    }
        
    //gibt eine Referenz zu Player2 zurück. Lenni
    public Player2 getPlayer2()
    {
        return thePlayer2;
    }

    //gibt eine Referenz zu Player1 zurück. Lenni
    public Player1 getPlayer1()
    {
        return thePlayer1;
    }    
    
    public void reduceLife(int player)
    {
        // Lebensanzeige: Game speichert Leben der Spieler und kümmert sich um die komplette Lebensanzeige. Flo.Ben.Arne
        if (player == 1 && counter1 == 0) //Wenn zwei Bomben einen Spieler geleizeitig treffen, wird diesem nur ein Leben abgezogen. Flo
        {
            p1Leben--; // Leben abziehen. Flo.Ben.Arne
            Verletzung1++;
            removeObject(theAnzeige1);
            // Lebensanzeige hinzufügen. Flo
            theAnzeige1 = new Leben (p1Leben, player, 0, 0, 1);
            addObject(theAnzeige1, 858, 30);
            thePlayer1.verletzen();
            if (p1Leben == 0)
            {
                GameOver gameOver = new GameOver(2); // übermittelt, welcher Spieler gewonnen hat. Flo.Ben.Arne
                addObject(gameOver, 525, 450); // fügt GameOver Screen hinzu. Flo
            }
            counter1 = 20;
        }        
        else if (player == 2 && counter2 == 0) 
        {
            p2Leben--; // Leben abziehen. Flo.Ben.Arne
            Verletzung2++;
            removeObject(theAnzeige2);
            // Lebensanzeige hinzufügen. Flo.Ben.Arne
            theAnzeige2 = new Leben (p2Leben, player, 0, 0, 1);
            addObject(theAnzeige2, 194, 30); 
            thePlayer2.verletzen();
            if (p2Leben == 0)
            {
                GameOver gameOver = new GameOver(1); // übermittelt, welcher Spieler gewonnen hat. Flo.Ben.Arne
                addObject(gameOver, 525, 450); // fügt GameOver Screen hinzu. Flo
            }
            counter2 = 20;
        }
    }
    
    private void wall()
    {
        // erstellt die obere Reihe der Mauer. Flo
        for (int i = 125; i<926; i = i+50)
        {
            Stein stein = new Stein();
            addObject(stein, i, 75);
        }
        // erstellt die untere Reihe der Mauer. Flo
        for (int i = 125; i<926; i = i+50)
        {
            Stein stein = new Stein();
            addObject(stein, i, 875);
        }
        // erstellt die linke Reihe der Mauer. Flo
        for (int j = 75; j<826; j=j+50)
        {
            Stein stein = new Stein();
            addObject(stein, 125, j);
        }
        // erstellt die rechte Reihe der Mauer. Flo
        for (int j = 75; j<826; j=j+50)
        {
            Stein stein = new Stein();
            addObject(stein, 925, j);
        }
    }
}
