 

import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Explosion here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Explosion extends Effekte
{
    /**
     * Act - do whatever the Explosion wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    int h;
    int radius, chaos;
    
    //hier bekommt die Explosiun den Radius von der Bombe übermittelt. Lenni
    public Explosion(int r, int c)
    {
        radius = r;
        chaos = c;
    }
    
    public void act() 
    {
        h++;
        radius();
        
        getWorld().addObject(new Ausweitung(chaos), getX(), getY()); // Spieler wird auch entfernt, wenn er auf dem Platz der Bombe stehen bleibt. Flo
        if (h == 1) // Explosion wird nun früher gelöscht -> Löst Problem mit unzerstörbaren Blöcken (Explosion ging über die Blöcke hinaus). Flo
        {
            getWorld().removeObject(this);
            return;
        }

    }    

    public void radius()
    // Abhängig vom Radius wird Ausweitung aufgerufen. Jedoch nur, wenn keine zerstörbaren/unzerstörbaren Blöcke dies verhindern. Lenni&Flo
    {
        for(int i = 1; i <= radius; i++)
        // For-Schleife für Richtung nach oben. Lenni&Flo
        {
            Actor Unzerstörbar = getOneObjectAtOffset(0, -50*i, unzerstBloecke.class);
            Actor Zerstörbar = getOneObjectAtOffset(0, -50*i, zerstBloecke.class);
            
            if(Unzerstörbar != null) 
            {
                i = radius +1;
            }
            else if(Zerstörbar != null)
            {
                getWorld().addObject(new Ausweitung(chaos), getX(), getY()-50*i);
                i = radius +1;
            }
            else
            {
                getWorld().addObject(new Ausweitung(chaos), getX(), getY()-50*i);
            }
        }
        for(int i = 1; i <= radius; i++)
        // For-Schleife für Richtung nach unten. Lenni&Flo
        {
            Actor Unzerstörbar = getOneObjectAtOffset(0, 50*i, unzerstBloecke.class);
            Actor Zerstörbar = getOneObjectAtOffset(0, 50*i, zerstBloecke.class);
            
            if(Unzerstörbar != null) 
            {
                i = radius +1;
            }
            else if(Zerstörbar != null)
            {
                getWorld().addObject(new Ausweitung(chaos), getX(), getY()+50*i);
                i = radius +1;
            }
            else
            {
                getWorld().addObject(new Ausweitung(chaos), getX(), getY()+50*i);
            }
        }
        for(int i = 1; i <= radius; i++)
        // For-Schleife für Richtung nach links. Lenni&Flo
        {
            Actor Unzerstörbar = getOneObjectAtOffset(-50*i, 0, unzerstBloecke.class);
            Actor Zerstörbar = getOneObjectAtOffset(-50*i, 0, zerstBloecke.class);
            
            if(Unzerstörbar != null) 
            {
                i = radius +1;
            }
            else if(Zerstörbar != null)
            {
                getWorld().addObject(new Ausweitung(chaos), getX()-50*i, getY());
                i = radius +1;
            }
            else
            {
                getWorld().addObject(new Ausweitung(chaos), getX()-50*i, getY());
            }
        }
        for(int i = 1; i <= radius; i++)
        // For-Schleife für Richtung nach rechts. Lenni&Flo
        {
            Actor Unzerstörbar = getOneObjectAtOffset(50*i, 0, unzerstBloecke.class);
            Actor Zerstörbar = getOneObjectAtOffset(50*i, 0, zerstBloecke.class);
            
            if(Unzerstörbar != null) 
            {
                i = radius +1;
            }
            else if(Zerstörbar != null)
            {
                getWorld().addObject(new Ausweitung(chaos), getX()+50*i, getY());
                i = radius +1;
            }
            else
            {
                getWorld().addObject(new Ausweitung(chaos), getX()+50*i, getY());
            }
        }
        
        
        
        // Code für Radius = 2
        /**
        if (h == 1)   {
        // Schaut im Umfeld von einem Block (50px), ob sich ein Block befindet. Wenn ja, wird keine Ausweitung aufgerufen. (Vorbereitung dafür) Flo
        Actor BlockOb = getOneObjectAtOffset(0, -50, unzerstBloecke.class);
        Actor BlockUn = getOneObjectAtOffset(0, 50, unzerstBloecke.class);
        Actor BlockLi = getOneObjectAtOffset(-50, 0, unzerstBloecke.class);
        Actor BlockRe = getOneObjectAtOffset(50, 0, unzerstBloecke.class);
        // Schaut, ob sich im Radius 2 (1000px) ein Block befindet. Wenn ja, wird keine Ausweitung aufgerufen. (Vorbereitung dafür) Flo
        Actor BlockOb2 = getOneObjectAtOffset(0, -100, unzerstBloecke.class);
        Actor BlockUn2 = getOneObjectAtOffset(0, 100, unzerstBloecke.class);
        Actor BlockLi2 = getOneObjectAtOffset(-100, 0, unzerstBloecke.class);
        Actor BlockRe2 = getOneObjectAtOffset(100, 0, unzerstBloecke.class);

        if (BlockOb == null) // Wenn oben kein Block ist, Ausweitung aufrufen. Flo
        {
        getWorld().addObject(new Ausweitung(), getX(), getY()-50);
        if (BlockOb2 == null) // Wenn oben kein Block ist UND dahinter auch keiner, rufe Ausweitung auf und verursache so eine Explosion. Flo
        {
        getWorld().addObject(new Ausweitung(), getX(), getY()-100);
        }
        }
        if (BlockUn== null) // Wenn unten kein Block ist, Ausweitung aufrufen. Flo
        {
        getWorld().addObject(new Ausweitung(), getX(), getY()+50);
        if (BlockUn2 == null)  // Wenn unten kein Block ist UND dahinter auch keiner, rufe Ausweitung auf und verursache so eine Explosion. Flo
        {
        getWorld().addObject(new Ausweitung(), getX(), getY()+100);
        }
        }
        if (BlockLi == null) // Wenn links kein Block ist, Ausweitung aufrufen. Flo
        {
        getWorld().addObject(new Ausweitung(), getX()-50, getY());
        if (BlockLi2 == null)  // Wenn links kein Block ist UND dahinter auch keiner, rufe Ausweitung auf und verursache so eine Explosion. Flo
        {
        getWorld().addObject(new Ausweitung(), getX()-100, getY());
        }
        }
        if (BlockRe == null) // Wenn rechts kein Block ist, Ausweitung aufrufen. Flo
        {
        getWorld().addObject(new Ausweitung(), getX()+50, getY());
        if (BlockRe2 == null)  // Wenn rechts kein Block ist UND dahinter auch keiner, rufe Ausweitung auf und verursache so eine Explosion. Flo
        {
        getWorld().addObject(new Ausweitung(), getX()+100, getY());
        }
        }
        }
         */
    }
}  

