 

import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Gegner2 here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Gegner2 extends Gegner
{
 private int bombs = 1, radius = 1, speed = 2, x, y, z = 0;
    public void act()
    {
        movement();
        newBomb();
        upgrade();
    }

    /**
     * legt eine Bombe, sobald Leertaste (space) gedrückt wird und bombs größer null ist.
     */
    public void newBomb()
    {
        //Verzögerung nachdem man eine Bombe gelgt hat. Ansonsten würde man auch bei kurzem Antippen der Leertaste mehrere Bomben direkt hintereinander auf ein und die Selbe Stelle legen. Lenni
        if(z > 0)
        {
            z--;
        }
        
        if (Greenfoot.isKeyDown("space") && (bombs > 0) && z == 0)
        {
            //zentriert die Bombe in die Mitte des Feldes, in welches man sich gerade befindet.Lenni
            int k,x,y;
            k = getX()/100;
            x = getX()- k*100;
            if(x < 50)
            {
                x = 25 + k*100;
            }
            else
            {
                x = 75 + k*100;
            }
            k = getY()/100;
            y = getY()- k*100;
            if(y < 50)
            {
                y = 25 + k*100;
            }
            else
            {
                y = 75 + k*100;
            }

            //legt die Bombe. Flo
            Bomb bomb = new Bomb(radius, 2, 0);

            getWorld().addObject( bomb, x, y);
            bombs--; //man hat nun eine Bombe weniger. Lenni
            
            //diese funktion verändert die Verzögerung in Abhängigkeit von der Geschwindigkeit, sodass es auch nach einer Erhöhung der Geschwindigkeit möglich bleibt beim laufen mit gedrückter Leertaste eine Bombe in jedes Feld zu legen. Lenni
            z = ((41/134)*(speed^3)) - ((263/134)*(speed^2)) - (4*speed) + (2573/67);
            
        }
    }

    //diese Funktion führt die Bombe aus, sobald sie explodiert, sodass man wieder eine Bombe zur Verfügung stehen hat. Lenni
    public void bombsPlus()
    {
       bombs++;
    }

    public void upgrade()
    {
        Actor Speed = getOneObjectAtOffset(0, 0, Speed.class);
        if (Speed != null) 
        { 
            //Maximalgeschwindigkeit festlegen. Lenni
            if(speed < 5)
            {
                speed++;
            }
            getWorld().removeObject(Speed);
        } //Wenn player speed einsammelt, erhöhe speed um 1 .Ben.Basti.Arne.Benny

        //falls man auf einem Radius-Upgrade steht, wird radius erhöht und das Upgrade entfernt. Lenni
        Actor Radius = getOneObjectAtOffset(0, 0, Radius.class);
        if (Radius != null) 
        { 
            //Maximalradius. Lenni
            if(radius < 15)
            {
                radius++;
            }
            getWorld().removeObject(Radius);
        } //Wenn player Radius einsammelt, erhöhe speed um 1 .Ben
        //s.o. Lenni
        Actor ExtraBombe = getOneObjectAtOffset(0, 0, ExtraBombe.class);
        if (ExtraBombe != null) 
        { 
            if(bombs < 15)
            {
                bombs++;
            }
            getWorld().removeObject(ExtraBombe);
        }
    }

    /**
     * sorgt für die Bewegung des Players.
     */
    public void movement()
    {
        //schaut, wo Hindernisse(Blöcke) sind. Durch versetzte Abfragepunkt(14, anstatt 20) muss man beim Abbiegen die Lücke nicht exakt treffen. Lenni&Flo
        Actor ObenRechts = getOneObjectAtOffset(11, -20, Bloecke.class);
        Actor ObenLinks = getOneObjectAtOffset(-11, -20, Bloecke.class);
        Actor UntenRechts = getOneObjectAtOffset(11, 20, Bloecke.class);
        Actor UntenLinks = getOneObjectAtOffset(-11, 20, Bloecke.class);
        Actor LinksOben = getOneObjectAtOffset(-20, -11, Bloecke.class);
        Actor LinksUnten = getOneObjectAtOffset(-20, 11, Bloecke.class);
        Actor RechtsOben = getOneObjectAtOffset(20, -11, Bloecke.class);
        Actor RechtsUnten = getOneObjectAtOffset(20, 11, Bloecke.class);
        
        //schaut, wo Bomben sind .Ben 
        Actor ObenRechtsB = getOneObjectAtOffset(11, -20, Waffen.class);
        Actor ObenLinksB = getOneObjectAtOffset(-11, -20, Waffen.class);
        Actor UntenRechtsB = getOneObjectAtOffset(11, 20, Waffen.class);
        Actor UntenLinksB = getOneObjectAtOffset(-11, 20, Waffen.class);
        Actor LinksObenB = getOneObjectAtOffset(-20, -11, Waffen.class);
        Actor LinksUntenB = getOneObjectAtOffset(-20, 11, Waffen.class);
        Actor RechtsObenB = getOneObjectAtOffset(20, -11, Waffen.class);
        Actor RechtsUntenB = getOneObjectAtOffset(20, 11, Waffen.class);
        //Bewegung. Es wird nur eine Bewegungsrichtung zugelassen(links oder rechts oder oben...). Flo

        if (Greenfoot.isKeyDown("w") && ObenRechts == null && ObenLinks == null && ObenRechtsB == null && ObenLinksB == null  )//falls über einem kein Block ist. Lenni und keine Bome.Ben
        {
            setRotation(269);
            //setImage(p2u);
            move(speed);

            //Wenn man die Ecken schneidet, was ja durch die versetzten Abfragepunkte möglich ist(s.o.), wird man wieder weiter auf die "Fahrbahn" verschoben, sodass sich das Bild des Spielers nicht mit dem Block schneidet. Lenni
            if(RechtsOben != null)
            {
                setLocation(getX()-1,getY());
            }
            else if(LinksOben != null)
            {
                setLocation(getX()+1,getY());
            }
        }
        else if (Greenfoot.isKeyDown("s") && UntenRechts == null && UntenLinks == null && UntenRechtsB == null && UntenLinksB == null)
        {
            setRotation(89);
            //setImage(p2d);
            move(speed);

            if(RechtsUnten != null)
            {
                setLocation(getX()-1,getY());
            }
            else if(LinksUnten != null)
            {
                setLocation(getX()+1,getY());
            }
        }
        else if (Greenfoot.isKeyDown("a") && LinksOben == null && LinksUnten == null && LinksObenB == null && LinksUntenB == null )
        {
            setRotation(179);
            //setImage(p2l);
            move(speed);
            if(ObenLinks != null)
            {
                setLocation(getX(),getY()+1);
            }
            else if(UntenLinks != null)
            {
                setLocation(getX(),getY()-1);
            }
        }
        else if (Greenfoot.isKeyDown("d") && RechtsOben == null && RechtsUnten == null && RechtsObenB == null && RechtsUntenB == null )
        {
            setRotation(0);
            //setImage(p2r);
            move(speed);
            if(ObenRechts != null)
            {
                setLocation(getX(),getY()+1);
            }
            else if(UntenRechts != null)
            {
                setLocation(getX(),getY()-1);
            }
        }
    }
}
/*    public void act() 
    {
        movement();
    } 
    public void movement ()
    {
        //von Player1/2 teilweise übernommen .Ben
        int z = 1;
        Actor ObenRechts = getOneObjectAtOffset(11, -20, Bloecke.class);
        Actor ObenLinks = getOneObjectAtOffset(-11, -20, Bloecke.class);
        Actor UntenRechts = getOneObjectAtOffset(11, 20, Bloecke.class);
        Actor UntenLinks = getOneObjectAtOffset(-11, 20, Bloecke.class);
        Actor LinksOben = getOneObjectAtOffset(-20, -11, Bloecke.class);
        Actor LinksUnten = getOneObjectAtOffset(-20, 11, Bloecke.class);
        Actor RechtsOben = getOneObjectAtOffset(20, -11, Bloecke.class);
        Actor RechtsUnten = getOneObjectAtOffset(20, 11, Bloecke.class);

           if (Greenfoot.getRandomNumber(50) == 0 && ObenRechts == null && ObenLinks == null ) //falls über einem kein Block ist. Lenni
           {   
            setRotation(269);
            move(6);
            if(RechtsOben != null)
            {                       
            setLocation(getX()-1,getY());
            }
            else if(LinksOben != null)
            {
            setLocation(getX()+1,getY());
            }
           
            }
  
           else if (Greenfoot.getRandomNumber(50) == 1 && UntenRechts == null && UntenLinks == null)
            {
            setRotation(89);
            move(6);
            if(RechtsUnten != null)
            {
                setLocation(getX()-1,getY());
            }
            else if(LinksUnten != null)
            {
                setLocation(getX()+1,getY());
            }
      
           }
           else if (Greenfoot.getRandomNumber(50) == 2 && LinksOben == null && LinksUnten == null)
           {
            setRotation(179);
            move(6);
            if(ObenLinks != null)
            {
                setLocation(getX(),getY()+1);
            }
            else if(UntenLinks != null)
            {
                setLocation(getX(),getY()-1);
            }
           }
            else if (Greenfoot.getRandomNumber(50) == 3 && RechtsOben == null && RechtsUnten == null)
           {
            setRotation(0);
            move(6);
            if(ObenRechts != null)
            {
                setLocation(getX(),getY()+1);
            }
            else if(UntenRechts != null)
            {
                setLocation(getX(),getY()-1);
            }
            }   
    
        }
*/ 
    




